package john111898.ld30.gui;

import java.awt.Graphics;
import java.util.ArrayList;

import john111898.ld30.gui.elements.GUIButtonImage;
import john111898.ld30.gui.elements.GUIButtonImageNoSheet;
import john111898.ld30.gui.elements.IGUIObject;

public class GUI {
	public int x;
	public int y;
	public String id;
	
	protected ArrayList<IGUIObject> objects = new ArrayList<IGUIObject>();
	
	public GUI(int x, int y, String id) {
		this.x = x;
		this.y = y;
		this.id = id;
	}
	
	public void draw(Graphics g) {
		for (IGUIObject o : objects) {
			o.draw(g);
		}
	}
	
	public GUI addObject(IGUIObject o) {
		objects.add(o);
		return this;
	}
	
	public IGUIObject click(int x, int y) {
		for (IGUIObject o : objects) {
			if ((o instanceof GUIButtonImage && o.isMouseOver(x, y)) || (o instanceof GUIButtonImageNoSheet && o.isMouseOver(x, y))) {
				return o;
			}
		}
		return null;
	}
	
	public IGUIObject objectByInfo(String info) {
		for (IGUIObject o : objects) {
			String test = o.getObjectInfo();
			if (test == null) {
				return null;
			}
			if (test.equals(info)) {
				return o;
			}
		}
		return null;
	}
}