package john111898.ld30.gui;

import java.awt.Color;

import javax.swing.JLabel;

import john111898.ld30.Main;
import john111898.ld30.gui.elements.GUIImage;
import john111898.ld30.gui.elements.GUIText;
import john111898.ld30.resources.ResourceCount;
import john111898.ld30.tile.Tile;
import john111898.ld30.tile.buildings.TileAdvancedToolsmith;
import john111898.ld30.tile.buildings.TileAluminumMine;
import john111898.ld30.tile.buildings.TileCarbonFiberManufactory;
import john111898.ld30.tile.buildings.TileCeramicsFactory;
import john111898.ld30.tile.buildings.TileCoalMine;
import john111898.ld30.tile.buildings.TileConcreteProducer;
import john111898.ld30.tile.buildings.TileElectronicsFactory;
import john111898.ld30.tile.buildings.TileForest;
import john111898.ld30.tile.buildings.TileFuelRefinery;
import john111898.ld30.tile.buildings.TileGlassGatherer;
import john111898.ld30.tile.buildings.TileGoldMine;
import john111898.ld30.tile.buildings.TileIndustrialLogger;
import john111898.ld30.tile.buildings.TileIronMine;
import john111898.ld30.tile.buildings.TileLargeHouse;
import john111898.ld30.tile.buildings.TileMediumHouse;
import john111898.ld30.tile.buildings.TileOilWell;
import john111898.ld30.tile.buildings.TilePlasticsFactory;
import john111898.ld30.tile.buildings.TileRecycler;
import john111898.ld30.tile.buildings.TileSignalDisrupter;
import john111898.ld30.tile.buildings.TileSignalDisrupterII;
import john111898.ld30.tile.buildings.TileSignalEnhancer;
import john111898.ld30.tile.buildings.TileSignalEnhancerII;
import john111898.ld30.tile.buildings.TileSmallHouse;
import john111898.ld30.tile.buildings.TileSpacecraftFactory;
import john111898.ld30.tile.buildings.TileSteelFactory;
import john111898.ld30.tile.buildings.TileStoneMine;
import john111898.ld30.tile.buildings.TileTitaniumMine;
import john111898.ld30.tile.buildings.TileToolsmith;
import john111898.ld30.tile.buildings.TileVeryLargeHouse;
import john111898.ld30.world.World;

public class GUIGameOver extends GUI {

	boolean playerSpaceFirst;
	World playerWorld;
	ResourceCount player;
	
	int simWorldPoints;
	ResourceCount sim;
	
	public GUIGameOver(boolean playerSpaceFirst, World playerWorld, ResourceCount player, int simWorldPoints, ResourceCount sim) {
		super(340, 75, "gameover");
		this.playerSpaceFirst = playerSpaceFirst;
		this.playerWorld = playerWorld;
		this.player = player;
		this.simWorldPoints = simWorldPoints;
		this.sim = sim;
		init();
	}
	
	private void init() {
		addObject(new GUIImage("image-back", Main.guiBackResources, 0, 0, 600, 600, 0, 0, this));
		int playerScore = 0;
		int simScore = 0;
		if (playerSpaceFirst) {
			playerScore = 200 + calcResourceScore(player) + calcWorldScore(playerWorld);
			simScore = simWorldPoints + calcResourceScore(sim);
		}
		else {
			playerScore = calcResourceScore(player) + calcWorldScore(playerWorld);
			simScore = 200 + simWorldPoints + calcResourceScore(sim);
		}
		if (playerScore > simScore) {
			addObject(new GUIText("text-title", "You win!", new Color(0, 153, 0), new JLabel().getFont().deriveFont(40.0f), 10, 70, this, false, 0));
		}
		else {
			addObject(new GUIText("text-title", "You lose!", Color.red, new JLabel().getFont().deriveFont(40.0f), 10, 70, this, false, 0));
		}
		addObject(new GUIText("text-playerScore", "Your score: " + playerScore, Color.black, new JLabel().getFont().deriveFont(30.0f), 10, 120, this, false, 0));
		addObject(new GUIText("text-playerBuildings", calcWorldScore(playerWorld) + " from buildings.", Color.black, new JLabel().getFont().deriveFont(26.0f), 50, 150, this, false, 0));
		addObject(new GUIText("text-playerResources", calcResourceScore(player) + " from resources.", Color.black, new JLabel().getFont().deriveFont(26.0f), 50, 180, this, false, 0));
		if (playerSpaceFirst) {
			addObject(new GUIText("text-playerSpace", "200 from reaching space.", Color.black, new JLabel().getFont().deriveFont(26.0f), 50, 210, this, false, 0));
			addObject(new GUIText("text-enemyScore", "Enemy score: " + simScore, Color.black, new JLabel().getFont().deriveFont(30.0f), 10, 260, this, false, 0));
			addObject(new GUIText("text-enemyBuildings", simWorldPoints + " from buildings.", Color.black, new JLabel().getFont().deriveFont(26.0f), 50, 290, this, false, 0));
			addObject(new GUIText("text-enemyResources", calcResourceScore(sim) + " from resources.", Color.black, new JLabel().getFont().deriveFont(26.0f), 50, 320, this, false, 0));
		} else {
			addObject(new GUIText("text-playerSpace", "200 from reaching space.", Color.black, new JLabel().getFont().deriveFont(26.0f), 50, 320, this, false, 0));
			addObject(new GUIText("text-enemyScore", "Enemy score: " + simScore, Color.black, new JLabel().getFont().deriveFont(30.0f), 10, 230, this, false, 0));
			addObject(new GUIText("text-enemyBuildings", simWorldPoints + " from buildings.", Color.black, new JLabel().getFont().deriveFont(26.0f), 50, 260, this, false, 0));
			addObject(new GUIText("text-enemyResources", calcResourceScore(sim) + " from resources.", Color.black, new JLabel().getFont().deriveFont(26.0f), 50, 290, this, false, 0));
		}
	}
	
	private int calcResourceScore(ResourceCount resources) {
		int score = 0;
		score += 0.01 * resources.numWood;
		score += 0.01 * resources.numStone;
		score += 0.01 * resources.numGlass;
		score += 0.05 * resources.numIron;
		score += 0.05 * resources.numGold;
		score += 0.05 * resources.numCoal;
		score += 0.1 * resources.numAluminum;
		score += 0.1 * resources.numOil;
		score += 0.1 * resources.numFuel;
		score += 0.1 * resources.numSteel;
		score += 0.1 * resources.numCeramics;
		score += 0.1 * resources.numPlastics;
		score += 0.25 * resources.numTitanium;
		score += 0.25 * resources.numElectronics;
		score += 0.25 * resources.numCarbonFiber;
		score += 0.25 * resources.numConcrete;
		
		return score;
	}
	
	private int calcWorldScore(World world) {
		Tile[][] tiles = world.getTiles();
		int score = 0;
		for (int i = 0; i < tiles.length; i++) {
			for (int j = 0; j < tiles[0].length; j++) {
				Tile t = tiles[i][j];
				if (t instanceof TileForest || t instanceof TileStoneMine || t instanceof TileToolsmith || t instanceof TileGlassGatherer || t instanceof TileSmallHouse) {
					score += 2;
				} else {
					if (t instanceof TileIronMine || t instanceof TileGoldMine || t instanceof TileCoalMine || t instanceof TileAdvancedToolsmith || t instanceof TileMediumHouse) {
						score += 4;
					} else {
						if (t instanceof TileAluminumMine || t instanceof TileOilWell || t instanceof TileFuelRefinery || t instanceof TileIndustrialLogger || t instanceof TileSignalDisrupter || t instanceof TileSignalEnhancer || t instanceof TileSteelFactory || t instanceof TileCeramicsFactory || t instanceof TilePlasticsFactory || t instanceof TileLargeHouse) {
							score += 7;
						} else {
							if (t instanceof TileTitaniumMine || t instanceof TileSignalDisrupterII || t instanceof TileSignalEnhancerII || t instanceof TileElectronicsFactory || t instanceof TileRecycler || t instanceof TileCarbonFiberManufactory || t instanceof TileConcreteProducer || t instanceof TileSpacecraftFactory || t instanceof TileVeryLargeHouse) {
								score += 10;
							}
						}
					}
				}
			}
		}
		return score;
	}
	
}