package john111898.ld30.gui;

import java.awt.Color;

import javax.swing.JLabel;

import john111898.ld30.Main;
import john111898.ld30.gui.elements.GUIButtonImageNoSheet;
import john111898.ld30.gui.elements.GUIImage;
import john111898.ld30.gui.elements.GUIText;
import john111898.ld30.resources.ResourceCount;

public class GUIGoals extends GUI {
	ResourceCount player;
	ResourceCount ageGoal;
	
	public GUIGoals(ResourceCount player, ResourceCount ageGoal) {
		super(340, 75, "goals");
		this.player = player;
		this.ageGoal = ageGoal;
		init();
	}
	
	private void init() {
		addObject(new GUIImage("image-back", Main.guiBackResources, 0, 0, 600, 600, 0, 0, this));
		addObject(new GUIText("text-goals", "Goals", Color.black, new JLabel().getFont().deriveFont(40.0f), 10, 65, this, false, 0));
		addObject(new GUIButtonImageNoSheet("button-close", Main.buttonCloseMenu, 230, 520, this));
		
		int[] playerNums = new int[] {player.numWood, player.numStone, player.numGlass, player.numIron, player.numGold, player.numCoal, player.numAluminum, player.numOil, player.numFuel, player.numSteel, player.numCeramics, player.numPlastics, player.numTitanium, player.numElectronics, player.numCarbonFiber, player.numConcrete};
		int[] goalNums = new int[] {ageGoal.numWood, ageGoal.numStone, ageGoal.numGlass, ageGoal.numIron, ageGoal.numGold, ageGoal.numCoal, ageGoal.numAluminum, ageGoal.numOil, ageGoal.numFuel, ageGoal.numSteel, ageGoal.numCeramics, ageGoal.numPlastics, ageGoal.numTitanium, ageGoal.numElectronics, ageGoal.numCarbonFiber, ageGoal.numConcrete};
		int numGoals = 0;
		for (int i = 0; i < 16; i++) {
			if (goalNums[i] > 0) {
				numGoals++;
				if (playerNums[i] >= goalNums[i]) {
					addObject(new GUIText("text-goal-" + getTypeFromNumber(i), getTypeFromNumber(i) + " (" + Integer.toString(playerNums[i]) + "/" + Integer.toString(goalNums[i]) + ")", new Color(41, 125, 6), new JLabel().getFont().deriveFont(36.0f), 10, 115 + numGoals * 50, this, false, 0));
				}
				else {
					addObject(new GUIText("text-goal-" + getTypeFromNumber(i), getTypeFromNumber(i) + " (" + Integer.toString(playerNums[i]) + "/" + Integer.toString(goalNums[i]) + ")", Color.red, new JLabel().getFont().deriveFont(36.0f), 10, 115 + numGoals * 50, this, false, 0));
				}
			}
		}
		if (numGoals == 0) {
			addObject(new GUIText("text-goal", "Make a Spacecraft Factory.", Color.black, new JLabel().getFont().deriveFont(36.0f), 10, 115, this, false, 0));
		}
	}
	
	private String getTypeFromNumber(int num) {
		switch(num) {
		case 0:
			return "Wood";
		case 1:
			return "Stone";
		case 2:
			return "Glass";
		case 3:
			return "Iron";
		case 4:
			return "Gold";
		case 5:
			return "Coal";
		case 6:
			return "Aluminum";
		case 7:
			return "Oil";
		case 8:
			return "Fuel";
		case 9:
			return "Steel";
		case 10:
			return "Ceramics";
		case 11:
			return "Plastics";
		case 12:
			return "Titanium";
		case 13:
			return "Electronics";
		case 14:
			return "Carbon Fiber";
		case 15:
			return "Concrete";
		}
		return null;
	}
}