package john111898.ld30.gui;

import java.awt.Color;

import javax.swing.JLabel;

import john111898.ld30.Main;
import john111898.ld30.gui.elements.GUIButtonImageNoSheet;
import john111898.ld30.gui.elements.GUIButtonImageScaled;
import john111898.ld30.gui.elements.GUIImage;
import john111898.ld30.gui.elements.GUIText;
import john111898.ld30.tile.Tile;

public class GUIItemSelect extends GUI {
	Tile[] tileTypes;
	String menuName;
	
	public GUIItemSelect(Tile[] tileTypes, String menuName) {
		super(50, 75, "select");
		this.tileTypes = tileTypes;
		this.menuName = menuName;
		generate();
	}
	
	public void generate() {
		addObject(new GUIImage("image-back", Main.guiBackItemSelect, 0, 0, 600, 600, 0, 0, this));
		addObject(new GUIText("text-name", menuName, Color.black, new JLabel().getFont().deriveFont(42.0f), 10, 50, this, false, 0));
		addObject(new GUIButtonImageNoSheet("button-close", Main.buttonCloseMenu, 10, 555, this));
		addObject(new GUIButtonImageNoSheet("button-moreinfo", Main.buttonMoreInfo, 450, 555, this));
		for (int i = 0; i < tileTypes.length; i++) {
			Tile t = tileTypes[i];
			if (i < 8) {
				addObject(new GUIButtonImageScaled("button-" + t.type.toLowerCase(), Main.tileSpritesheet, t.spriteX * 32, t.spriteY * 32, 32, 32, 36 + 24 * (i - 1) + 48 * i, 125, this, 48, 48));
				addObject(new GUIText("text-" + t.type.toLowerCase(), t.type, t.textColor, new JLabel().getFont().deriveFont(15.0f), 36 + 24 * (i - 1) + 48 * i, 103, this, true, 85));
				if (t.resources.resource1) {
					addObject(new GUIText("text-r1"+t.type.toLowerCase(), Integer.toString(t.resources.numR1), Color.black, new JLabel().getFont().deriveFont(18.0f), 36 + 24 * (i - 1) + 48 * i, 200, this, false, 0));
					addObject(new GUIText("text-r1r"+t.type.toLowerCase(), t.resources.r1.name, Color.black, new JLabel().getFont().deriveFont(10.0f), 54 + 4 * numDigits(t.resources.numR1) + 24 * (i - 1) + 48 * i, 198, this, false, 0));
				}
				if (t.resources.resource2) {
					addObject(new GUIText("text-r2"+t.type.toLowerCase(), Integer.toString(t.resources.numR2), Color.black, new JLabel().getFont().deriveFont(18.0f), 36 + 24 * (i - 1) + 48 * i, 225, this, false, 0));
					addObject(new GUIText("text-r2r"+t.type.toLowerCase(), t.resources.r2.name, Color.black, new JLabel().getFont().deriveFont(10.0f), 54 + 4 * numDigits(t.resources.numR2)  + 24 * (i - 1) + 48 * i, 223, this, false, 0));
				}
				if (t.resources.resource3) {
					addObject(new GUIText("text-r3"+t.type.toLowerCase(), Integer.toString(t.resources.numR3), Color.black, new JLabel().getFont().deriveFont(18.0f), 36 + 24 * (i - 1) + 48 * i, 250, this, false, 0));
					addObject(new GUIText("text-r3r"+t.type.toLowerCase(), t.resources.r3.name, Color.black, new JLabel().getFont().deriveFont(10.0f), 54 + 4 * numDigits(t.resources.numR3)  + 24 * (i - 1) + 48 * i, 248, this, false, 0));
				}
			} else {
				addObject(new GUIButtonImageScaled("button-" + t.type.toLowerCase(), Main.tileSpritesheet, t.spriteX * 32, t.spriteY * 32, 32, 32, 36 + 20 * (i - 9) + 48 * (i - 8), 355, this, 48, 48));
				addObject(new GUIText("text-" + t.type.toLowerCase(), t.type, t.textColor, new JLabel().getFont().deriveFont(15.0f), 36 + 20 * (i - 9) + 48 * (i - 8), 333, this, true, 75));
				if (t.resources.resource1) {
					addObject(new GUIText("text-r1"+t.type.toLowerCase(), Integer.toString(t.resources.numR1), Color.black, new JLabel().getFont().deriveFont(18.0f), 36 + 24 * (i - 9) + 48 * (i - 8), 430, this, false, 0));
					addObject(new GUIText("text-r1r"+t.type.toLowerCase(), t.resources.r1.name, Color.black, new JLabel().getFont().deriveFont(10.0f), 54 + 4 * numDigits(t.resources.numR1)  + 24 * (i - 9) + 48 * (i - 8), 428, this, false, 0));
				}
				if (t.resources.resource2) {
					addObject(new GUIText("text-r2"+t.type.toLowerCase(), Integer.toString(t.resources.numR2), Color.black, new JLabel().getFont().deriveFont(18.0f), 36 + 24 * (i - 9) + 48 * (i - 8), 455, this, false, 0));
					addObject(new GUIText("text-r2r"+t.type.toLowerCase(), t.resources.r2.name, Color.black, new JLabel().getFont().deriveFont(10.0f), 54 + 4 * numDigits(t.resources.numR2)  + 24 * (i - 9) + 48 * (i - 8), 453, this, false, 0));
				}
				if (t.resources.resource3) {
					addObject(new GUIText("text-r3"+t.type.toLowerCase(), Integer.toString(t.resources.numR3), Color.black, new JLabel().getFont().deriveFont(18.0f), 36 + 24 * (i - 9) + 48 * (i - 8), 480, this, false, 0));
					addObject(new GUIText("text-r3r"+t.type.toLowerCase(), t.resources.r3.name, Color.black, new JLabel().getFont().deriveFont(10.0f), 54 + 4 * numDigits(t.resources.numR3)  + 24 * (i - 9) + 48 * (i - 8), 478, this, false, 0));
				}
			}
		}
	}
	
	public int numDigits(int integer) {
		return String.valueOf(integer).length();
	}
}