package john111898.ld30.gui;

import java.awt.Color;

import javax.swing.JLabel;

import john111898.ld30.Main;
import john111898.ld30.gui.elements.GUIButtonImageNoSheet;
import john111898.ld30.gui.elements.GUIImage;
import john111898.ld30.gui.elements.GUIText;
import john111898.ld30.resources.ResourceCount;

public class GUIResources extends GUI {

	GUIText wood;
	GUIText stone;
	GUIText glass;
	GUIText iron;
	GUIText gold;
	GUIText coal;
	GUIText aluminum;
	GUIText oil;
	GUIText fuel;
	GUIText steel;
	GUIText ceramics;
	GUIText plastics;
	GUIText titanium;
	GUIText electronics;
	GUIText carbonFiber;
	GUIText concrete;
	
	public GUIResources() {
		super(340, 75, "resources");
		init();
	}
	
	public void init() {
		addObject(new GUIImage("image-back", Main.guiBackResources, 0, 0, 600, 600, 0, 0, this));
		addObject(new GUIText("text-resources", "Resources", Color.black, new JLabel().getFont().deriveFont(36.0f), 10, 60, this, false, 0));
		addObject(new GUIButtonImageNoSheet("button-close", Main.buttonCloseMenu, 430, 520, this));
		addObject(new GUIButtonImageNoSheet("button-you", Main.buttonResYou, 200, 30, this));
		addObject(new GUIButtonImageNoSheet("button-enemy", Main.buttonResEnemy, 330, 30, this));
		addObject(new GUIButtonImageNoSheet("button-universal", Main.buttonResUniversal, 460, 30, this));
	}
	
	public void setResources(ResourceCount resources) {
		if (wood != null) {
			objects.remove(wood);
			objects.remove(stone);
			objects.remove(glass);
			objects.remove(iron);
			objects.remove(gold);
			objects.remove(coal);
			objects.remove(aluminum);
			objects.remove(oil);
			objects.remove(fuel);
			objects.remove(steel);
			objects.remove(ceramics);
			objects.remove(plastics);
			objects.remove(titanium);
			objects.remove(electronics);
			objects.remove(carbonFiber);
			objects.remove(concrete);
		}
		wood = new GUIText("text-wood", resources.numWood + " Wood", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 120, this, false, 0);
		stone = new GUIText("text-stone", resources.numStone + " Stone", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 150, this, false, 0);
		glass = new GUIText("text-glass", resources.numGlass + " Glass", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 180, this, false, 0);
		iron = new GUIText("text-iron", resources.numIron + " Iron", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 210, this, false, 0);
		gold = new GUIText("text-gold", resources.numGold + " Gold", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 240, this, false, 0);
		coal = new GUIText("text-coal", resources.numCoal + " Coal", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 270, this, false, 0);
		aluminum = new GUIText("text-aluminum", resources.numAluminum + " Aluminum", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 300, this, false, 0);
		oil = new GUIText("text-oil", resources.numOil + " Oil", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 330, this, false, 0);
		fuel = new GUIText("text-fuel", resources.numFuel + " Fuel", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 360, this, false, 0);
		steel = new GUIText("text-steel", resources.numSteel + " Steel", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 390, this, false, 0);
		ceramics = new GUIText("text-ceramics", resources.numCeramics + " Ceramics", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 420, this, false, 0);
		plastics = new GUIText("text-plastics", resources.numPlastics + " Plastics", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 450, this, false, 0);
		titanium = new GUIText("text-titanium", resources.numTitanium + " Titanium", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 480, this, false, 0);
		electronics = new GUIText("text-electronics", resources.numElectronics + " Electronics", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 510, this, false, 0);
		carbonFiber = new GUIText("text-carbonFiber", resources.numCarbonFiber + " Carbon Fiber", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 540, this, false, 0);
		concrete = new GUIText("text-concrete", resources.numConcrete + " Concrete", Color.black, new JLabel().getFont().deriveFont(28.0f), 10, 570, this, false, 0);
		addObject(wood);
		addObject(stone);
		addObject(glass);
		addObject(iron);
		addObject(gold);
		addObject(coal);
		addObject(aluminum);
		addObject(oil);
		addObject(fuel);
		addObject(steel);
		addObject(ceramics);
		addObject(plastics);
		addObject(titanium);
		addObject(electronics);
		addObject(carbonFiber);
		addObject(concrete);
	}
}