package john111898.ld30.gui;

import java.awt.Color;

import javax.swing.JLabel;

import john111898.ld30.Main;
import john111898.ld30.gui.elements.GUIButtonImage;
import john111898.ld30.gui.elements.GUIButtonImageNoSheet;
import john111898.ld30.gui.elements.GUIImage;
import john111898.ld30.gui.elements.GUIText;
import john111898.ld30.tile.Tile;

public class GUITop extends GUI {
	GUIImage currentTile;
	GUIText currentTileText;
	GUIText r1Text;
	GUIText r2Text;
	GUIText r3Text;
	
	GUIText currentAge;
	
	public GUITop() {
		super(0, 0, "top");
		addObject(new GUIImage("image-topbg", Main.guiTop, 0, 0, 1280, 1280, 0, 0, this));
		addObject(new GUIButtonImageNoSheet("button-exit", Main.buttonExit, 1160, 4, this));
		addObject(new GUIImage("image-spacer1", Main.topSpacer, 0, 0, 4, 52, 1140, 0, this));
		addObject(new GUIButtonImage("button-space", Main.buildingButtonsSpritesheet, 0, 192, 48, 48, 1078, 2, this));
		addObject(new GUIButtonImage("button-industrial", Main.buildingButtonsSpritesheet, 0, 144, 48, 48, 1016, 2, this));
		addObject(new GUIButtonImage("button-iron", Main.buildingButtonsSpritesheet, 0, 96, 48, 48, 954, 2, this));
		addObject(new GUIButtonImage("button-stone", Main.buildingButtonsSpritesheet, 0, 48, 48, 48, 892, 2, this));
		addObject(new GUIImage("image-spacer2", Main.topSpacer, 0, 0, 4, 52, 874, 0, this));
		addObject(new GUIButtonImage("button-road", Main.buildingButtonsSpritesheet, 0, 0, 48, 48, 812, 2, this));
		addObject(new GUIImage("image-spacer3", Main.topSpacer, 0, 0, 4, 52, 794, 0, this));
		addObject(new GUIImage("image-spacer4", Main.topSpacer, 0, 0, 4, 52, 166, 0, this));
		addObject(new GUIButtonImageNoSheet("button-resources", Main.buttonResources, 180, 4, this));
		addObject(new GUIButtonImageNoSheet("button-goals", Main.buttonGoals, 320, 4, this));
		addObject(new GUIImage("image-spacer5", Main.topSpacer, 0, 0, 4, 52, 426, 0, this));
	}
	
	public void updateCurrentTile(Tile t) {
		if (currentTile == null) {
			currentTile = new GUIImage("image-currenttile", null, 0, 0, 32, 32, 484, 4, this);
			addObject(currentTile);
			currentTileText = new GUIText("text-tilename", "", Color.black, new JLabel().getFont(), 456, 48, this, false, 0);
			addObject(currentTileText);
			r1Text = new GUIText("text-r1", "", Color.black, new JLabel().getFont(), 500, 30, this, false, 0);
			r2Text = new GUIText("text-r2", "", Color.black, new JLabel().getFont(), 500, 40, this, false, 0);
			r3Text = new GUIText("text-r3", "", Color.black, new JLabel().getFont(), 500, 50, this, false, 0);
			addObject(r1Text);
			addObject(r2Text);
			addObject(r3Text);
		}
		addObject(new GUIText("text-current", "Current", Color.black, new JLabel().getFont(), 436, 16, this, false, 0));
		addObject(new GUIText("text-tile", "Tile", Color.black, new JLabel().getFont(), 448, 32, this, false, 0));
		objects.remove(currentTile);
		currentTile = new GUIImage("image-currenttile", t.spritesheet, t.spriteX * 32, t.spriteY * 32, 32, 32, 484, 4, this);
		objects.add(currentTile);
		objects.remove(currentTileText);
		currentTileText = new GUIText("text-tilename", t.type, t.textColor, new JLabel().getFont(), 491 - (int)(3.5 * t.type.length()), 48, this, false, 0);
		objects.add(currentTileText);
		objects.remove(r1Text);
		objects.remove(r2Text);
		objects.remove(r3Text);
		r1Text = new GUIText("text-r1", "", Color.black, new JLabel().getFont(), 500, 30, this, false, 0);
		r2Text = new GUIText("text-r2", "", Color.black, new JLabel().getFont(), 500, 40, this, false, 0);
		r3Text = new GUIText("text-r3", "", Color.black, new JLabel().getFont(), 500, 50, this, false, 0);
		if (t.resources.resource1) {
			r1Text = new GUIText("text-r1", t.resources.numR1 + " " + t.resources.r1.name, Color.black, new JLabel().getFont(), 530, 15, this, false, 0);
		}
		if (t.resources.resource2) {
			r2Text = new GUIText("text-r2", t.resources.numR2 + " " + t.resources.r2.name, Color.black, new JLabel().getFont(), 530, 25, this, false, 0);
		}
		if (t.resources.resource3) {
			r3Text = new GUIText("text-r3", t.resources.numR3 + " " + t.resources.r3.name, Color.black, new JLabel().getFont(), 530, 35, this, false, 0);
		}
		addObject(r1Text);
		addObject(r2Text);
		addObject(r3Text);
	}
	
	public void updateAge(String ageName) {
		if (currentAge == null) {
			currentAge = new GUIText("text-age", "Stone", Color.black, new JLabel().getFont().deriveFont(32.0f), 10, 36, this, false, 0);
			addObject(currentAge);
		}
		objects.remove(currentAge);
		currentAge = new GUIText("text-age", ageName, Color.black, new JLabel().getFont().deriveFont(32.0f), 10, 36, this, false, 0);
		objects.add(currentAge);
	}
}