package john111898.ld30.gui.elements;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import john111898.ld30.Main;
import john111898.ld30.gui.GUI;

public class GUIButtonImage extends GUIImage {
	protected boolean mouseOver = false;
	
	public GUIButtonImage(String buttonInfo, BufferedImage spritesheet, int sheetX, int sheetY, int sheetWidth, int sheetHeight, int guiX, int guiY, GUI gui) {
		super(buttonInfo, spritesheet, sheetX, sheetY, sheetWidth, sheetHeight, guiX, guiY, gui);
	}
	
	@Override
	public void draw(Graphics g) {
		g.drawImage(spritesheet, guiX + gui.x, guiY + gui.y, guiX + gui.x + sheetWidth, guiY + gui.y + sheetHeight, sheetX, sheetY, sheetX + sheetWidth, sheetY + sheetWidth, null); 
		isMouseOver(Main.mouseX, Main.mouseY);
		if (mouseOver) {
			g.setColor(new Color(92, 92, 92, 60));
			g.fillRect(guiX + gui.x, guiY + gui.y, sheetWidth, sheetHeight);
		}	
	}
	
	@Override
	public boolean isMouseOver(int x, int y) {
		int x1 = guiX + gui.x;
		int y1 = guiY + gui.y;
		int x2 = guiX + gui.x + sheetWidth;
		int y2 = guiY + gui.y + sheetHeight;
		
		mouseOver = (x >= x1 && x <= x2 && y >= y1 && y <= y2);
		return mouseOver;
	}
}