package john111898.ld30.gui.elements;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import john111898.ld30.Main;
import john111898.ld30.gui.GUI;

public class GUIButtonImageNoSheet implements IGUIObject {

	String objectInfo;
	
	BufferedImage image;
	
	int guiX;
	int guiY;
	
	GUI gui;
	
	boolean mouseOver;
	
	public GUIButtonImageNoSheet(String imageInfo, BufferedImage image, int guiX, int guiY, GUI gui) {
		objectInfo = imageInfo;
		this.image = image;
		this.guiX = guiX;
		this.guiY = guiY;
		this.gui = gui;
	}
	
	@Override
	public void draw(Graphics g) {
		g.drawImage(image, guiX + gui.x, guiY + gui.y, null);
		isMouseOver(Main.mouseX, Main.mouseY);
		if (mouseOver) {
			g.setColor(new Color(92, 92, 92, 60));
			g.fillRect(guiX + gui.x, guiY + gui.y, image.getWidth(), image.getHeight());
		}
	}

	@Override
	public boolean isMouseOver(int mouseX, int mouseY) {
		int x1 = guiX + gui.x;
		int y1 = guiY + gui.y;
		int x2 = guiX + gui.x + image.getWidth();
		int y2 = guiY + gui.y + image.getHeight();
		
		mouseOver = (mouseX >= x1 && mouseX <= x2 && mouseY >= y1 && mouseY <= y2);
		return mouseOver;
	}

	@Override
	public String getObjectInfo() {
		return objectInfo;
	}
	
	@Override
	public GUI getGUI() {
		return gui;
	}
	
}