package john111898.ld30.gui.elements;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;

import john111898.ld30.gui.GUI;
import john111898.ld30.util.TextWrap;

public class GUIText implements IGUIObject {
	String objectInfo;
	
	String text;
	Color color;
	Font font;
	
	int guiX;
	int guiY;
	
	GUI gui;
	
	boolean textWrap = false;
	int textWidth;
	
	public GUIText(String textInfo, String text, Color color, Font font, int guiX, int guiY, GUI gui, boolean textWrap, int textWidth) {
		objectInfo = textInfo;
		this.text = text;
		this.color = color;
		this.font = font;
		this.guiX = guiX;
		this.guiY = guiY;
		this.gui = gui;
		this.textWrap = textWrap;
		this.textWidth = textWidth;
	}
	
	@Override
	public void draw(Graphics g) {
		g.setColor(color);
		g.setFont(font);
		if (textWrap) {
			TextWrap.drawString(g, text, guiX + gui.x, guiY + gui.y, textWidth);
		} else {
			g.drawString(text, guiX + gui.x, guiY + gui.y);
		}
	}

	@Override
	public boolean isMouseOver(int mouseX, int mouseY) {
		return false;
	}

	@Override
	public String getObjectInfo() {
		return null;
	}

	@Override
	public GUI getGUI() {
		return gui;
	}
	
	public void setText(String text) {
		this.text = text;
	}
	
	public void setColor(Color color) {
		this.color = color;
	}
}