package john111898.ld30.tile;

import static john111898.ld30.Main.spriteSize;
import static john111898.ld30.Main.tileViewSize;
import static john111898.ld30.Main.viewOffsetX;
import static john111898.ld30.Main.viewOffsetY;
import static john111898.ld30.Main.yOffsetTopGUI;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import john111898.ld30.Main;
import john111898.ld30.resources.ResourceOutput;
import john111898.ld30.resources.ResourceRequirements;

public class Tile {
	public BufferedImage spritesheet;
	public int spriteX;
	public int spriteY;
	
	public int tileX;
	public int tileY;
	
	boolean mouseOver = false;
	
	public String type;
	public Color textColor;
	
	public ResourceRequirements resources;
	public ResourceOutput output;
	
	public Tile(int tileX, int tileY, BufferedImage spritesheet, int spriteX, int spriteY, String type, Color textColor, ResourceRequirements resources, ResourceOutput output) {
		this.tileX = tileX;
		this.tileY = tileY;
		this.spritesheet = spritesheet;
		this.spriteX = spriteX;
		this.spriteY = spriteY;
		this.type = type;
		this.textColor = textColor;
		this.resources = resources;
		this.output = output;
	}
	
	public void draw(Graphics g) {
		g.drawImage(spritesheet, (tileX * tileViewSize) + viewOffsetX, (tileY * tileViewSize) + viewOffsetY + yOffsetTopGUI, (tileX * tileViewSize) + tileViewSize + viewOffsetX, (tileY * tileViewSize) + tileViewSize + viewOffsetY + yOffsetTopGUI, spriteX * spriteSize, spriteY * spriteSize, (spriteX * spriteSize) + spriteSize, (spriteY * spriteSize) + spriteSize, null);
		if (mouseOver) {
			g.setColor(new Color(0, 255, 0, 75));
			g.fillRect((tileX * tileViewSize) + viewOffsetX, (tileY * tileViewSize) + viewOffsetY + yOffsetTopGUI, (tileX * tileViewSize) + viewOffsetX + tileViewSize, (tileY * tileViewSize) + viewOffsetY + yOffsetTopGUI + tileViewSize);
		}
	}
	
	public boolean isVisible() {
		if (((tileY * tileViewSize) + viewOffsetY + tileViewSize) > 0 && ((tileY * tileViewSize) + viewOffsetY) < Main.SCREEN_HEIGHT && ((tileX * tileViewSize) + viewOffsetX + tileViewSize) > 0 && ((tileX * tileViewSize) + viewOffsetX) < Main.SCREEN_WIDTH) {
			return true;
		}
		return false;
	}
	
	public boolean isMouseOver(int x, int y) {
		int x1 = (tileX * tileViewSize) + viewOffsetX;
		int y1 = (tileY * tileViewSize) + viewOffsetY + yOffsetTopGUI;
		int x2 = (tileX * tileViewSize) + viewOffsetX + tileViewSize;
		int y2 = (tileY * tileViewSize) + viewOffsetY + yOffsetTopGUI + tileViewSize;
		mouseOver = false;
		if (x >= x1 && x <= x2 && y >= y1 && y <= y2) {
			mouseOver = true;
		}
		return mouseOver;
	}
}