package john111898.ld30.util;

import java.net.URL;
import java.util.ArrayList;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.sound.sampled.FloatControl;

import john111898.ld30.Game;

public class SoundManager {
	ArrayList<Sound> sounds;
	
	String prefix = "res/";
	
	public SoundManager() {
		
	}
	
	public SoundManager(ArrayList<Sound> sounds) {
		this.sounds = sounds;
	}
	
	public SoundManager(Sound[] sounds) {
		for (Sound s : sounds) {
			this.sounds.add(s);
		}
	}
	
	public void setSounds(ArrayList<Sound> sounds) {
		this.sounds = sounds;
	}
	
	public void setSounds(Sound[] sounds) {
		for (Sound s : sounds) {
			this.sounds.add(s);
		}
	}
	
	public void setFilePrefix(String prefix) {
		this.prefix = prefix;
	}
	
	public void playSound(String filename, float decibelGain) {
		String file = prefix + filename;
		URL url = Game.class.getResource(file);
		try {
			AudioInputStream audioIn = AudioSystem.getAudioInputStream(url);
			Clip clip = AudioSystem.getClip();
			clip.open(audioIn);
			
			FloatControl volume = (FloatControl) clip.getControl(FloatControl.Type.MASTER_GAIN);
			volume.setValue(decibelGain);
			
			clip.start();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void playSound(String filename) {
		playSound(filename, 0.0f);
	}
	
	public void playSound(Sound s, float decibelGain) {
		playSound(s.getFilename(), decibelGain);
	}
	
	public void playSound(Sound s) {
		playSound(s, -15.0f);
	}
	
	public void playSound(int soundArrayIndex, float decibelGain) {
		playSound(sounds.get(soundArrayIndex), decibelGain);
	}
	
	public void playSound(int soundArrayIndex) {
		playSound(soundArrayIndex, 0.0f);
	}
}