package john111898.ld30.util;

import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;

public class TextWrap {
	public static void drawString(Graphics g, String text, int x, int y, int textWidth) {
		FontMetrics fm = g.getFontMetrics();
		int lineHeight = fm.getHeight();
		
		int currentX = x;
		int currentY = y;
		
		String[] words = text.split(" ");
		
		for (String s : words) {
			int wordWidth = fm.stringWidth(s + " ");
			if (currentX + wordWidth >= x + textWidth) {
				currentY += lineHeight;
				currentX = x;
			}
			g.drawString(s, currentX, currentY);
			currentX += wordWidth;
		}
	}
	
	public static void drawString(Graphics g, Font f, String text, int x, int y, int textWidth) {
		g.setFont(f);
		
		FontMetrics fm = g.getFontMetrics();
		int lineHeight = fm.getHeight();
		
		int currentX = x;
		int currentY = y;
		
		String[] words = text.split(" ");
		
		for (String s : words) {
			int wordWidth = fm.stringWidth(s + " ");
			if (currentX + wordWidth >= x + textWidth) {
				currentY += lineHeight;
			}
			g.drawString(s, currentX, currentY);
			currentX += wordWidth;
		}
	}
}