package john111898.ld30.world;

import john111898.ld30.Game;
import john111898.ld30.resources.ResourceCount;

public class SimulatedEnemy {
	public static final int EASY = 0;
	public static final int NORMAL = 1;
	public static final int HARD = 2;
	
	int age = Game.AGE_STONE;
	int difficulty = NORMAL;
	
	int turns = 0;
	
	boolean spaceshipReady = false;
	
	public SimulatedEnemy(int age, int difficulty) {
		this.age = age;
		this.difficulty = difficulty;
	}
	
	public void addResourceProduction(ResourceCount sim, ResourceCount universal, int disrupters, int disruptersII) {
		double minus = 0.15 * disrupters + 0.25 * disruptersII;
		if (minus > 0.5) {
			minus = 0.5;
		}
		switch(age) {
		case Game.AGE_STONE:
			sim.numStone += 15 - 15 * minus;
			universal.numStone -= 30 - 30 * minus;
			sim.numWood += 15 - 15 * minus;
			universal.numWood -= 30 - 30 * minus;
			sim.numGlass += 3 - 3 * minus;
			universal.numGlass -= 6 - 6 * minus;
			break;
		case Game.AGE_IRON:
			sim.numIron += 15 - 15 * minus;
			universal.numIron -= 30 - 30 * minus;
			sim.numGold += 4 - 4 * minus;
			universal.numGold -= 8 - 8 * minus;
			sim.numCoal += 15 - 15 * minus;
			universal.numCoal -= 30 - 30 * minus;
			break;
		case Game.AGE_INDUSTRIAL:
			sim.numAluminum += 8 - 8 * minus;
			universal.numAluminum -= 16 - 16 * minus;
			sim.numFuel += 2 - 2 * minus;
			universal.numFuel -= 4 - 4 * minus;
			sim.numOil += 3 - 3 * minus;
			universal.numOil -= 6 - 6 * minus;
			sim.numCeramics += 2 - 2 * minus;
			universal.numCeramics -= 4 - 4 * minus;
			sim.numSteel += 2 - 2 * minus;
			universal.numSteel -= 4 - 4 * minus;
			sim.numPlastics += 2 - 2 * minus;
			universal.numPlastics -= 4 - 4 * minus;
			break;
		case Game.AGE_SPACE:
			sim.numTitanium += 2 - 2 * minus;
			universal.numTitanium -= 4 - 4 * minus;
			sim.numElectronics += 2 - 2 * minus;
			universal.numElectronics -= 4 - 4 * minus;
			sim.numConcrete += 1 - 1 * minus;
			universal.numConcrete -= 2 - 2 * minus;
			sim.numCarbonFiber += 2 - 2 * minus;
			universal.numCarbonFiber -= 4 - 4 * minus;
			break;
		}
		turns++;
	}
	
	public int getBuildingsValue() {
		switch(age) {
		case Game.AGE_STONE:
			return 35 - (100 / turns);
		case Game.AGE_IRON:
			return 150 - (100 / turns);
		case Game.AGE_INDUSTRIAL:
			return 275 - (100 / turns);
		case Game.AGE_SPACE:
			return 400 - (100 / turns);
		}
		return 0;
	}
	
	public boolean spaceshipReady() {
		if (turns >= 60) {
			return true;
		}
		return false;
	}
	
	public void setAge(int age) {
		this.age = age;
	}
}